import { Enum } from './utils.js'


export const AddressMode = Enum(
  'clamp-to-edge',
  'repeat',
  'mirror-repeat'
)

export const AutoLayoutMode = Enum('auto')

export const BlendFactor = Enum(
  'zero',
  'one',
  'src',
  'one-minus-src',
  'src-alpha',
  'one-minus-src-alpha',
  'dst',
  'one-minus-dst',
  'dst-alpha',
  'one-minus-dst-alpha',
  'src-alpha-saturated',
  'constant',
  'one-minus-constant',
  'src1',
  'one-minus-src1',
  'src1-alpha',
  'one-minus-src1-alpha'
)


export const BlendOperation = Enum(
  'add',
  'subtract',
  'reverse-subtract',
  'min',
  'max'
)

export const BufferBindingType = Enum(
  'uniform',
  'storage',
  'read-only-storage'
)

export const BufferMapState = Enum(
  'unmapped',
  'pending',
  'mapped'
)

export const CanvasAlphaMode = Enum(
  'opaque',
  'premultiplied'
)

export const CanvasToneMappingMode = Enum(
  'standard',
  'extended'
)

export const CompareFunction = Enum(
  'never',
  'less',
  'equal',
  'less-equal',
  'greater',
  'not-equal',
  'greater-equal',
  'always'
)

export const CompilationMessageType = Enum(
  'error',
  'warning',
  'info'
)

export const CullMode = Enum(
  'none',
  'front',
  'back'
)

export const DeviceLostReason = Enum(
  'unknown',
  'destroyed'
)

export const ErrorFilter = Enum(
  'validation',
  'out-of-memory',
  'internal'
)

export const FeatureName = Enum(
  'depth-clip-control',
  'depth32float-stencil8',
  'texture-compression-bc',
  'texture-compression-bc-sliced-3d',
  'texture-compression-etc2',
  'texture-compression-astc',
  'texture-compression-astc-sliced-3d',
  'timestamp-query',
  'indirect-first-instance',
  'shader-f16',
  'rg11b10ufloat-renderable',
  'bgra8unorm-storage',
  'float32-filterable',
  'float32-blendable',
  'clip-distances',
  'dual-source-blending'
)

export const FilterMode = Enum(
  'nearest',
  'linear'
)

export const FrontFace = Enum(
  'ccw',
  'cw'
)

export const IndexFormat = Enum(
  'uint16',
  'uint32'
)

export const LoadOp = Enum(
  'load',
  'clear'
)

export const MipmapFilterMode = Enum(
  'nearest',
  'linear'
)

export const PipelineErrorReason = Enum(
  'validation',
  'internal'
)

export const PowerPreference = Enum(
  'low-power',
  'high-performance'
)

export const PrimitiveTopology = Enum(
  'point-list',
  'line-list',
  'line-strip',
  'triangle-list',
  'triangle-strip'
)

export const QueryType = Enum(
  'occlusion',
  'timestamp'
)

export const SamplerBindingType = Enum(
  'filtering',
  'non-filtering',
  'comparison'
)

export const StencilOperation = Enum(
  'keep',
  'zero',
  'replace',
  'invert',
  'increment-clamp',
  'decrement-clamp',
  'increment-wrap',
  'decrement-wrap'
)

export const StorageTextureAccess = Enum(
  'write-only',
  'read-only',
  'read-write'
)

export const StoreOp = Enum(
  'store',
  'discard'
)

export const TextureAspect = Enum(
  'all',
  'stencil-only',
  'depth-only'
)

export const TextureDimension = Enum(
  '1d',
  '2d',
  '3d'
)

export const TextureFormat = Enum(
  'r8unorm',
  'r8snorm',
  'r8uint',
  'r8sint',
  'r16uint',
  'r16sint',
  'r16float',
  'rg8unorm',
  'rg8snorm',
  'rg8uint',
  'rg8sint',
  'r32uint',
  'r32sint',
  'r32float',
  'rg16uint',
  'rg16sint',
  'rg16float',
  'rgba8unorm',
  'rgba8unorm-srgb',
  'rgba8snorm',
  'rgba8uint',
  'rgba8sint',
  'bgra8unorm',
  'bgra8unorm-srgb',
  'rgb9e5ufloat',
  'rgb10a2uint',
  'rgb10a2unorm',
  'rg11b10ufloat',
  'rg32uint',
  'rg32sint',
  'rg32float',
  'rgba16uint',
  'rgba16sint',
  'rgba16float',
  'rgba32uint',
  'rgba32sint',
  'rgba32float',
  'stencil8',
  'depth16unorm',
  'depth24plus',
  'depth24plus-stencil8',
  'depth32float',
  'depth32float-stencil8',
  'bc1-rgba-unorm',
  'bc1-rgba-unorm-srgb',
  'bc2-rgba-unorm',
  'bc2-rgba-unorm-srgb',
  'bc3-rgba-unorm',
  'bc3-rgba-unorm-srgb',
  'bc4-r-unorm',
  'bc4-r-snorm',
  'bc5-rg-unorm',
  'bc5-rg-snorm',
  'bc6h-rgb-ufloat',
  'bc6h-rgb-float',
  'bc7-rgba-unorm',
  'bc7-rgba-unorm-srgb',
  'etc2-rgb8unorm',
  'etc2-rgb8unorm-srgb',
  'etc2-rgb8a1unorm',
  'etc2-rgb8a1unorm-srgb',
  'etc2-rgba8unorm',
  'etc2-rgba8unorm-srgb',
  'eac-r11unorm',
  'eac-r11snorm',
  'eac-rg11unorm',
  'eac-rg11snorm',
  'astc-4x4-unorm',
  'astc-4x4-unorm-srgb',
  'astc-5x4-unorm',
  'astc-5x4-unorm-srgb',
  'astc-5x5-unorm',
  'astc-5x5-unorm-srgb',
  'astc-6x5-unorm',
  'astc-6x5-unorm-srgb',
  'astc-6x6-unorm',
  'astc-6x6-unorm-srgb',
  'astc-8x5-unorm',
  'astc-8x5-unorm-srgb',
  'astc-8x6-unorm',
  'astc-8x6-unorm-srgb',
  'astc-8x8-unorm',
  'astc-8x8-unorm-srgb',
  'astc-10x5-unorm',
  'astc-10x5-unorm-srgb',
  'astc-10x6-unorm',
  'astc-10x6-unorm-srgb',
  'astc-10x8-unorm',
  'astc-10x8-unorm-srgb',
  'astc-10x10-unorm',
  'astc-10x10-unorm-srgb',
  'astc-12x10-unorm',
  'astc-12x10-unorm-srgb',
  'astc-12x12-unorm',
  'astc-12x12-unorm-srgb'
)

export const TextureSampleType = Enum(
  'float',
  'unfilterable-float',
  'depth',
  'sint',
  'uint'
)

export const TextureViewDimension = Enum(
  '1d',
  '2d',
  '2d-array',
  'cube',
  'cube-array',
  '3d'
)

export const VertexFormat = Enum(
  'uint8x2',
  'uint8x4',
  'sint8x2',
  'sint8x4',
  'unorm8x2',
  'unorm8x4',
  'snorm8x2',
  'snorm8x4',
  'uint16x2',
  'uint16x4',
  'sint16x2',
  'sint16x4',
  'unorm16x2',
  'unorm16x4',
  'snorm16x2',
  'snorm16x4',
  'float16x2',
  'float16x4',
  'float32',
  'float32x2',
  'float32x3',
  'float32x4',
  'uint32',
  'uint32x2',
  'uint32x3',
  'uint32x4',
  'sint32',
  'sint32x2',
  'sint32x3',
  'sint32x4',
  'unorm10-10-10-2'
)

export const VertexStepMode = Enum(
  'vertex',
  'instance'
)
