import { WebGPUObjectError } from '../utils/errors.js'

export class BindGroupLayout {
  _device
  _handle

  get handle() {
    return this._handle
  }

  get label() {
    return this._handle.label
  }

  /**
   * @param {GPUDevice} device
   * @param {GPUBindGroupLayout} layout
   */
  constructor(device, layout) {
    this._device = device
    this._handle = layout
  }

  /**
   * @param {GPUDevice} device
   * @param {GPUBindGroupLayoutDescriptor} descriptor
   */
  static create(device, descriptor) {
    try {
      return new BindGroupLayout(
        device,
        device.createBindGroupLayout(descriptor)
      )
    } catch (err) {
      throw WebGPUObjectError.from(err, BindGroupLayout)
    }
  }
}

